class B {
  float xpos;
  float ypos;
  float zpos;
  float ang;
  float stro;
  float trans;
  float brot;

  float v=-1;

  void display() {
    pushMatrix();
    translate(0, -MapMax, 0);

    for (int i=0; i<dataMatrix.length; i++) {      
      bWid = map(dataMatrix[i][0], bMin, bMax, MapMin, MapMax);
      brot = map(dataMatrix[i][0], bMin, bMax, 0, PI/2);//rotationMapping
      stro = map(dataMatrix[i][0], bMin, bMax, 0, 1); //strokeMapping
      trans = map(dataMatrix[i][0], bMin, bMax, 100, 200);//transparency Mapping
      ypos = bWid;
      xpos = i/12 * wUnit;
      zpos = i%12 * lUnit;

      pushMatrix();
      noStroke();
      translate(-rectX/2, 0, 0);
      //point with line
      pushMatrix();
      translate(xpos, -ypos, -zpos);
      fill(black);
      rect(0, offset, 2, brot*20);
      //text
      textAlign(CENTER, CENTER);    
      fill(black, 200);
      noStroke();
      textFont(Gotham);
      textSize(4);
      rect(0, ypos-4, 10, 2);
      text(startYear+i/12+" / "+(1+i%12), 0, ypos);
      //
      strokeWeight(strokeL/1.5);
      stroke(black);       
      line(0, 0, 0, bWid);
      strokeWeight(.2);//netline  

      //draw bmax     
      if (i==6) {
        fill(black);
        noStroke();
        ellipseMode(RIGHT);
        sphere(offset);
        //MAX
        pushMatrix();
        rotateZ(PI/2);
        textAlign(CENTER, CENTER);    
        fill(black, 200);
        noStroke();
        textFont(Gotham);
        textSize(10);    
        text("Maximum Checkout Numbers", -MapMax, 0 );
        popMatrix();
      } else if (i==dataMatrix.length-10||i==dataMatrix.length-6) {
        //draw min
        fill(black);
        noStroke();
        rect(0, 0, -MapMax/2, MapMax/20);
        //min
        textAlign(RIGHT, CENTER);                 
        fill(black, 200);
        rect(-MapMax/2, MapMax/20-MapMax+offset, 20, 7);
        strokeWeight(strokeL);
        stroke(black);
        line(-MapMax/2, MapMax/20-MapMax, -MapMax/2, MapMax/20);
        noStroke();
        textFont(Gotham);
        textSize(5);    
        text("Minimum Checkout Numbers", -MapMax/2, MapMax/20-MapMax );
      } else if (i == 43 || i==44) {
        rect(0, 0, -MapMax/40, -MapMax);
        strokeWeight(strokeL);
        line(0, 0, 0, -MapMax*2);
        text("Artist's personal life change", -MapMax/2, -MapMax*2 );
        noStroke();
        fill(black);
        ellipse(0, -MapMax*2+offset, -MapMax/10, MapMax/10);
      } else {
  fill(black, 200);
  noStroke();
  ellipse(0, 0, brot*5+2, brot*5+2);
}


popMatrix();

//netpad 
for (int l=0; l<12; l++) {   
  stroke(grey, 70);
  strokeWeight(strokeL/2);
  line(0, -l*3, rectX, -l*3);//front
  pushMatrix();
  translate(0, 0, -rectZ);
  line(0, -l*3, rectX, -l*3);//behind
  popMatrix();   
  noStroke();
  fill(black, 255);     
  rect(0, 0, rectX, 2);//X-AXIS     
  pushMatrix();
  rotateY(radians(90));
  translate(0, 0, rectX);
  rect(0, 0, rectZ, 2);     
  popMatrix();
}   
popMatrix();
}

//title
textAlign(LEFT, CENTER);    

noStroke();
textFont(Gotham);
textSize(10);
fill(black);
rect(rectX/2+MapMax/2, -10, 50+offset, 7);
fill(black, 200);
text("BACK TO BLACK", rectX/2+MapMax/2, 0 );
popMatrix();
}
}