class F {
  float xpos;
  float ypos;
  float zpos;
  float stro;
  float trans;
  float frot;


  void display() {
    pushMatrix();
    for (int i=0; i<dataMatrix.length; i++) {      
      fWid = map(dataMatrix[i][2], fMin, fMax, MapMin, MapMax);
      frot = map(dataMatrix[i][2], fMin, fMax, 0, PI/2);//rotationMapping
      stro = map(dataMatrix[i][2], fMin, fMax, 0, 1); //strokeMapping

      trans = map(dataMatrix[i][2], fMin, fMax, 100, 200);//transparency Mapping
      ypos = fWid;
      xpos = i/12 * wUnit;
      zpos = i%12 * lUnit;

      pushMatrix();
      translate(-rectX/2, 0, 0);
      //point with line
      pushMatrix();
      translate(xpos, -ypos, -zpos);
      fill(black);
      noStroke();
      //text
      textAlign(CENTER, CENTER);    
      fill(black, 200);
      noStroke();
      textFont(Gotham);
      textSize(4);
      rect(0, ypos-4, 10, 2);
      text(startYear+i/12+" / "+(1+i%12), 0, ypos);
      //
      noStroke();
      fill(red);
      rect(0, -offset, 2, frot*20);
      strokeWeight(strokeL/2);
      stroke(black);      
      line(0, 0, 0, fWid);
      strokeWeight(.2);//netline  
      //draw fmax
      if (i==12) {
        fill(red);
        noStroke();
        ellipseMode(RIGHT);
        sphere(offset);
        //MAX
        pushMatrix();
        rotateZ(PI/2);
        textAlign(CENTER, CENTER);    
        fill(red, 200);
        noStroke();
        textFont(Gotham);
        textSize(10);    
        text("Maximum Checkout Numbers", -MapMax, 0 );
        popMatrix();
      } else if (i==42 || i==43) {//special points  
        fill(black);
        rect(0, 0, -MapMax/40, MapMax);
        strokeWeight(strokeL);
        stroke(black);
        line(0, 0, 0, MapMax*4);
        text("summer tour", MapMax/7, 0);
        noStroke();
        fill(red);
        ellipse(0, MapMax*4-offset, -MapMax/10, MapMax/10);
      }else if (i<6) {
        //draw min
        fill(black);
        noStroke();
        rect(0, 0, -MapMax/2, -MapMax/20);   
        //min
        textAlign(RIGHT, CENTER);    
        fill(black, 200);
        noStroke();
        textFont(Gotham);
        textSize(5);    
        text("Minimum Checkout Numbers", -MapMax/2-10, MapMax/20 );
        //connect min with other min
        stroke(black);
        strokeWeight(strokeL);
        line(0,0,0,MapMax-offset*2);
        
      } else {
        fill(red);
        noStroke();
        ellipse(0, 0, frot*5+2, frot*5+2);
      }
      popMatrix();

      //netpad
      for (int l=0; l<12; l++) {   
        stroke(grey, 20);
        strokeWeight(strokeL/2);
        line(0, -l*3, rectX, -l*3);//front lines
        pushMatrix();
        translate(0, 0, -rectZ);
        line(0, -l*3, rectX, -l*3);//back lines
        popMatrix();
        fill(black, 255);
        rect(0, 0, rectX, 1);//X-AXIS  
        pushMatrix();
        rotateY(radians(90));
        translate(0, 0, rectX);
        rect(0, 0, rectZ, 10);     
        popMatrix();
      }

      popMatrix();
    }
    //title
    textAlign(LEFT, CENTER);  
    fill(red);
    rect(rectX/2+MapMax/2, -10, 50-offset, 7);
    fill(black, 200);
    noStroke();
    textFont(Gotham);
    textSize(10);    
    text("FLEET FOXES", rectX/2+MapMax/2, 0 );
    popMatrix();
  }
}