class N {
  float xpos;
  float ypos;
  float zpos;
  float stro;
  float trans;
  float nrot;
  float  ang;

  void display() {
    pushMatrix();
    translate(0, MapMax, 0);

    for (int i=0; i<dataMatrix.length; i++) {      
      nWid = map(dataMatrix[i][3], nMin, nMax, MapMin, MapMax);
      nrot = map(dataMatrix[i][3], nMin, nMax, 0, PI/2);//rotationMapping
      stro = map(dataMatrix[i][3], nMin, nMax, 0, 1); //strokeMapping

      trans = map(dataMatrix[i][3], nMin, nMax, 100, 200);//transparency Mapping
      ypos = nWid;
      xpos = i/12 * wUnit;
      zpos = i%12 * lUnit;

      pushMatrix();
      translate(-rectX/2, 0, 0);
      //point with line
      pushMatrix();
      translate(xpos, -ypos, -zpos);
      fill(black);
      //rotate(frot);
      rect(0, offset, 2, 20*nrot);
      //text
      textAlign(CENTER, CENTER);    
      fill(black, 200);
      noStroke();
      textFont(Gotham);
      textSize(4);
      rect(0, ypos-4, 10, 2);
      text(startYear+i/12+" / "+(1+i%12), 0, ypos);
      //
      strokeWeight(strokeL/2);
      stroke(black);       
      line(0, 0, 0, nWid);
      strokeWeight(.2);//netline  
      //draw fmax
      if (i==57) {
        fill(black);
        ellipseMode(RIGHT);
        sphere(offset);
        //MAX
         pushMatrix();
        rotateZ(PI/2);
        textAlign(CENTER, CENTER);    
        fill(black, 200);
        noStroke();
        textFont(Gotham);
        textSize(10);    
        text("Maximum Checkout Numbers", -MapMax,0 );
        popMatrix();
      } else if (i==42 || i==43 || i==dataMatrix.length-12) {//special points  
        fill(black);
        rect(0, 0, -MapMax/40, -MapMax);
        strokeWeight(strokeL);
        stroke(black);
        line(0, 0, 0, -MapMax*4);
        text("Artist's next album released", MapMax/7, 0);
        noStroke();
        fill(black);
        ellipse(0, -MapMax*4+offset, -MapMax/10, MapMax/10);
      }else if (i<4) {
        //draw min
        fill(black);
        noStroke();
        rect(0, 0, -MapMax/2, -MapMax/20);
        //min
        textAlign(RIGHT, CENTER);    
        fill(black, 200);
        noStroke();
        textFont(Gotham);
        textSize(5);    
        text("Minimum Checkout Numbers", -MapMax/2-10, MapMax/20 );
      } else {
        fill(black);
        noStroke();
        ellipse(0, 0, nrot*5+2, nrot*5+2);
      }
      popMatrix();

      //netpad
      for (int l=0; l<12; l++) {   
        stroke(grey, 20);
        strokeWeight(strokeL/2);
        line(0, -l*3, rectX, -l*3);
        pushMatrix();
        translate(0, 0, -rectZ);
        line(0, -l*3, rectX, -l*3);
        popMatrix();
        noStroke();
        fill(black, 255);
        rect(0, 0, rectX, 2);//X-AXIS

        pushMatrix();
        rotateY(radians(90));
        translate(0, 0, rectX);
        rect(0, 0, rectZ, 2);     
        popMatrix();
      }


      popMatrix();
    }
    //title
    textAlign(LEFT, CENTER);    
     fill(black);
    rect(rectX/2+MapMax/2, -10,50+offset,7);
    fill(black, 200);
    noStroke();
    textFont(Gotham);
    textSize(10);    
    text("NINETEEN", rectX/2+MapMax/2, 0 );
    popMatrix();
  }
}