class V {
  float xpos;
  float ypos;
  float zpos;
  float ang;
  float stro;
  float trans;
  float vrot;

  void display() {
    pushMatrix();

    translate(0, MapMax*2, 0);

    for (int i=0; i<dataMatrix.length; i++) {      
      vWid = map(dataMatrix[i][1], vMin, vMax, MapMin, MapMax);
      vrot = map(dataMatrix[i][1], vMin, vMax, 0, PI/2);//rotationMapping
      stro = map(dataMatrix[i][1], vMin, vMax, 0, 1); //strokeMapping

      trans = map(dataMatrix[i][1], vMin, vMax, 100, 200);//transparency Mapping
      ypos = vWid;
      xpos = i/12 * wUnit;
      zpos = i%12 * lUnit;

      pushMatrix();
      translate(-rectX/2, 0, 0);
      //point with line
      pushMatrix();
      translate(xpos, -ypos, -zpos);
      fill(red);
      rect(0, -offset, 2, 20*vrot);
      //text
      textAlign(CENTER, CENTER);    
      fill(black, 200);
      noStroke();
      textFont(Gotham);
      textSize(4);
      rect(0, ypos-4, 10, 2);
      text(startYear+i/12+" / "+(1+i%12), 0, ypos);
      //
      strokeWeight(strokeL/2);
      stroke(black);       
      line(0, 0, 0, vWid);
      strokeWeight(.2);//netline  
      //draw fmax
      if (i==6) {
        fill(red);
        ellipseMode(RIGHT);
        noStroke();
        sphere(offset);
        //MAX
        pushMatrix();
        rotateZ(PI/2);
        textAlign(CENTER, CENTER);    
        fill(red, 200);
        noStroke();
        textFont(Gotham);
        textSize(10);    
        text("Maximum Checkout Numbers", -MapMax, 0 );
        popMatrix();
      } else if (i==0||i==dataMatrix.length-1) {
        //draw min
        fill(black);
        noStroke();
        rect(0, 0, MapMax/2, -MapMax/20);
        rect(0, 0, -MapMax/2, -MapMax/20);
        //min
        textAlign(RIGHT, CENTER);    
        fill(black, 200);
        noStroke();
        textFont(Gotham);
        textSize(5);    
        text("Minimum Checkout Numbers", -MapMax/2-10, MapMax/20 );
        //connect min with other min
        stroke(black);
        strokeWeight(strokeL);
        line(0, 0, 0, -MapMax+offset*2);
      } else if (i==24 || i==25) {//special points       
        rect(0, 0, -MapMax/20, -MapMax);
        strokeWeight(strokeL);
        line(0, 0, 0, MapMax*2);
        text("FEATURED IN TV SHOW", -MapMax/2, MapMax*2 );
        noStroke();
        fill(black);
        ellipse(0, MapMax*2-offset, -MapMax/10, MapMax/10);
      } else {
        fill(red);
        noStroke();
        ellipse(0, 0, vrot*5+2, vrot*5+2);
      }
      popMatrix();

      //netpad
      for (int l=0; l<12; l++) {   
        stroke(grey, 20);
        strokeWeight(strokeL/2);
        line(0, -l*3, rectX, -l*3);
        pushMatrix();
        translate(0, 0, -rectZ);
        line(0, -l*3, rectX, -l*3);
        popMatrix();
        noStroke();
        fill(black, 255);
        rect(0, 0, rectX, 2);//X-AXIS
        //Z-axis
        pushMatrix();
        rotateY(radians(90));
        rect(0, 0, rectZ, 10);
        popMatrix();
        pushMatrix();
        rotateY(radians(90));
        translate(0, 0, rectX);
        rect(0, 0, rectZ, 10);     
        popMatrix();
      }


      popMatrix();
    }

    //title
    textAlign(LEFT, CENTER);   
    fill(red);
    rect(rectX/2+MapMax/2, -10, 50-offset, 7);
    fill(black, 200);
    noStroke();
    textFont(Gotham);
    textSize(10);    
    text("VAMPIRE FOREST", rectX/2+MapMax/2, 0 );

    popMatrix();
  }
}