import peasy.*;
PeasyCam cam;
PImage img; 

Table table;
int numRows, numColumns;
float[][] dataMatrix;
float bMax, bMin, vMax, vMin, fMax, fMin, nMax, nMin;
float bWid, vWid, nWid, fWid; //z-axis
float rectX=800, rectZ= 600, wUnit=rectX/9, lUnit=rectZ/11;//height,width
color black =color(0, 0, 0), grey=180, red=color(181, 7, 26, 255), yellow=color(241, 215, 3);
;
color white = color(235, 235, 235);
float strokeL = 1.5, strokeS=3, strokeC=1.5;
PFont Din;
PFont Gotham;
float bUnit=.1, vUnit=3, fUnit=4, nUnit=4;
int startYear = 2008; 
int value=0;
float r, ang, vAng;
float rectH=15;
float rectW=40;
B b;
V vc;
F f;
N n;
Cnt c;
float offset, v=1;
Inter inter;
float MapMax =100, MapMin=0;

void setup() {
  //background(white-20);
  fullScreen(P3D);
  //size(1080, 900, P3D);
  cam = new PeasyCam(this, 1000);
  surface.setResizable(true);
  Din = createFont("DIN.otf", 32);
  Gotham = createFont("Gotham-Bold.otf", 32);

  b = new B ();
  vc = new V();
  f = new F();
  n = new N();
  c = new Cnt();
  inter = new Inter();
  //setup Table
  table = loadTable ("soulVSrock.csv", "header");
  numRows = table.getRowCount();
  numColumns = table.getColumnCount();
  dataMatrix = new float [numColumns-4][numRows];
  println("Rows: " + numRows + " Columns: " + numColumns);

  for (int i=0; i<numColumns-4; i++) {
    for (int j=0; j<numRows; j++) {
      dataMatrix[i][j] = table.getFloat(j, i+4);
    }
  }

  //maxValue and minValue //back to black
  for (int i=0; i < dataMatrix.length; i++) {
    if (dataMatrix[i][0]>bMax ) {
      bMax = dataMatrix [i][0];
      println ("bmax"+bMax);//i=6,bmax=121
    }
  }

  //maxValue and minValue //Vampire Weekend
  for (int i=0; i < dataMatrix.length; i++) {
    if (dataMatrix[i][1]>vMax ) {
      vMax = dataMatrix [i][1];
      println ("vmax"+vMax+i);//i=6,bmax=140
    }
  }
  //min and max of fleet foxes
  for (int i=0; i < dataMatrix.length; i++) {
    if (dataMatrix[i][2]>fMax ) {
      fMax = dataMatrix [i][2];
      println("fleetMax"+fMax+i);//146 12
      println(fMin+""+i);
    }
  }
  //min and max of 19
  for (int i=0; i < dataMatrix.length; i++) {
    if (dataMatrix[i][3]>nMax ) {
      nMax = dataMatrix [i][3];
      println("19"+nMax+i); //123 57
    }
  }

  nMin = 0;
  fMin = 0;

  vMin = 0;
  bMin = 7;
}

void draw() {
  offset=offset+v;
  if (offset>40||offset<0) {
    v=-v;
  }
  // noCursor();
  ang = ang+vAng;

  background(white);

  pushMatrix();
  inter.display(); 
  rotateY(radians(ang));
  translate(0, 0, rectZ/2);

  b.display();
  f.display();
  n.display();
  vc.display();
  c.display();
  popMatrix();
  inter.Text();
 //   saveFrame();
}
//void mousePressed() {
//  saveFrame();
//}